Project Chrono: chrono::vehicle::TrackAssemblyBandBushing Class Reference

Public Member Functions | List of all members
chrono::vehicle::TrackAssemblyBandBushing Class Reference
VEHICLE module » Tracked vehicles

## Description

Band-bushing track assembly model constructed from a JSON specification file.

`#include <TrackAssemblyBandBushing.h>`

Inheritance diagram for chrono::vehicle::TrackAssemblyBandBushing:
[legend]
Collaboration diagram for chrono::vehicle::TrackAssemblyBandBushing:
[legend]

## Public Member Functions
| TrackAssemblyBandBushing (const std::string &filename)
| TrackAssemblyBandBushing (const rapidjson::Document &d)
virtual const ChVector3d | GetSprocketLocation () const override
| Get the relative location of the sprocket subsystem.
virtual const ChVector3d | GetIdlerLocation () const override
| Get the relative location of the idler subsystem.
virtual const ChVector3d | GetRoadWhelAssemblyLocation (int which) const override
| Get the relative location of the specified suspension subsystem.
virtual const ChVector3d | GetRollerLocation (int which) const override
| Get the relative location of the specified roller subsystem.
Public Member Functions inherited from chrono::vehicle::ChTrackAssemblyBandBushing
| ChTrackAssemblyBandBushing (const std::string &name, VehicleSide side)
| Construct a bushing-based track assembly on the specified vehicle side.
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual size_t | GetNumTrackShoes () const override
| Get the number of track shoes.
virtual std::shared_ptr< ChTrackShoe > | GetTrackShoe (size_t id) const override
| Get a handle to the specified track shoe subsystem.
Public Member Functions inherited from chrono::vehicle::ChTrackAssemblyBand
| ChTrackAssemblyBand (const std::string &name, VehicleSide side)
virtual std::shared_ptr< ChSprocket > | GetSprocket () const override
| Get a handle to the sprocket.
Public Member Functions inherited from chrono::vehicle::ChTrackAssembly
VehicleSide | GetVehicleSide () const
| Return the vehicle side for this track assembly.
size_t | GetNumTrackSuspensions () const
| Get the number of suspensions.
size_t | GetNumRollers () const
| Get the number of rollers.
std::shared_ptr< ChIdler > | GetIdler () const
| Get a handle to the idler subsystem.
std::shared_ptr< ChTrackWheel > | GetIdlerWheel () const
| Get a handle to the idelr wheel subsystem.
std::shared_ptr< ChTrackBrake > | GetBrake () const
| Get a handle to the brake subsystem.
const ChTrackSuspensionList & | GetTrackSuspensions () const
| Get the list of suspension subsystems.
std::shared_ptr< ChTrackSuspension > | GetTrackSuspension (size_t id) const
| Get a handle to the specified suspension subsystem.
std::shared_ptr< ChTrackWheel > | GetRoller (size_t id) const
| Get a handle to the specified roller subsystem.
std::shared_ptr< ChTrackWheel > | GetRoadWheel (size_t id) const
| Get a handle to the specified road wheel subsystem.
const ChVector3d & | GetTrackShoePos (size_t id) const
| Get the global location of the specified track shoe.
const ChQuaternion & | GetTrackShoeRot (size_t id) const
| Get the orientation of the specified track shoe.
const ChVector3d & | GetTrackShoeLinVel (size_t id) const
| Get the linear velocity of the specified track shoe.
ChVector3d | GetTrackShoeAngVel (size_t id) const
| Get the angular velocity of the specified track shoe.
ChVector3d | GetTrackShoeTension (size_t id) const
| Get track tension at the specified track shoe.
BodyState | GetTrackShoeState (size_t id) const
| Get the complete state for the specified track shoe.
void | GetTrackShoeStates (BodyStates &states) const
| Get the complete states for all track shoes.
void | Initialize (std::shared_ptr< ChChassis > chassis, const ChVector3d &location, bool create_shoes=true)
| Initialize this track assembly subsystem.
double | ReportTrackLength () const
| Return total assembled track length (sum of pitch over all track shoes).
ChTrackSuspension::ForceTorque | ReportSuspensionForce (size_t id) const
| Return current suspension forces or torques, as appropriate (spring and shock) for the specified suspension.
void | SetSprocketVisualizationType (VisualizationType vis)
| Set visualization type for the sprocket subsystem.
void | SetIdlerVisualizationType (VisualizationType vis)
void | SetSuspensionVisualizationType (VisualizationType vis)
| Set visualization type for the suspension subsystems.
void | SetIdlerWheelVisualizationType (VisualizationType vis)
| Set visualization type for the idler-wheel subsystems.
void | SetRoadWheelVisualizationType (VisualizationType vis)
| Set visualization type for the road-wheel subsystems.
void | SetRollerVisualizationType (VisualizationType vis)
| Set visualization type for the roller subsystems.
void | SetTrackShoeVisualizationType (VisualizationType vis)
| Set visualization type for the track shoe subsystems.
void | SetWheelCollisionType (bool roadwheel_as_cylinder, bool idler_as_cylinder, bool roller_as_cylinder)
| Set collision shape type for wheels.
void | Synchronize (double time, double braking)
| Update the state of this track assembly at the current time.
void | Synchronize (double time, double braking, const TerrainForces &shoe_forces)
| Update the state of this track assembly at the current time.
virtual void | Advance (double step)
| Advance the state of this track assembly by the specified time step.
virtual void | SetOutput (bool state) override
| Enable/disable output for this subsystem.
void | LogConstraintViolations ()
| Log current constraint violations.
bool | IsRoadwheelCylinder () const
bool | IsIdlerCylinder () const
bool | IsRolerCylinder () const
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis)
| Add visualization assets to this subsystem, for the specified visualization mode.
virtual void | RemoveVisualizationAssets ()
| Remove all visualization assets from this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChTrackAssemblyBand
bool | FindAssemblyPoints (std::shared_ptr< ChBodyAuxRef > chassis, int num_shoes, const std::vector< double > &connection_lengths, std::vector< ChVector2d > &shoe_points)
| Assembly Algorithm Utility Functions.
void | FindCircleTangentPoints (ChVector2d Circle1Pos, double Circle1Rad, ChVector2d Circle2Pos, double Circle2Rad, ChVector2d &Tan1Pnt1, ChVector2d &Tan1Pnt2, ChVector2d &Tan2Pnt1, ChVector2d &Tan2Pnt2)
void | CheckCircleCircle (bool &found, ChVector2d &Point, ChMatrixDynamic<> &Features, int FeatureIdx, ChVector2d &StartingPoint, double Radius)
void | CheckCircleLine (bool &found, ChVector2d &Point, ChMatrixDynamic<> &Features, int FeatureIdx, ChVector2d &StartingPoint, double Radius)
Protected Member Functions inherited from chrono::vehicle::ChTrackAssembly
| ChTrackAssembly (const std::string &name, VehicleSide side)
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChTrackAssemblyBandBushing
ChTrackShoeBandBushingList | m_shoes
| track shoes
Protected Attributes inherited from chrono::vehicle::ChTrackAssemblyBand
std::shared_ptr< ChSprocketBand > | m_sprocket
| sprocket subsystem
double | m_sprocket_offset
Protected Attributes inherited from chrono::vehicle::ChTrackAssembly
VehicleSide | m_side
| assembly on left/right vehicle side
ChVector3d | m_rel_loc
| assembly location relative to chassis
std::shared_ptr< ChIdler > | m_idler
| idler (and tensioner) subsystem
std::shared_ptr< ChTrackBrake > | m_brake
| sprocket brake
ChTrackSuspensionList | m_suspensions
| road-wheel assemblies
ChTrackWheelList | m_rollers
| roller subsystems
bool | m_roadwheel_as_cylinder
bool | m_idler_as_cylinder
bool | m_roller_as_cylinder
std::vector< std::shared_ptr< ChLoadBodyForce > > | m_shoe_terrain_forces
| terrain force loads on track shoes
std::vector< std::shared_ptr< ChLoadBodyTorque > > | m_shoe_terrain_torques
| terrain torque loads on track shoes
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetIdlerLocation()

virtual const ChVector3d chrono::vehicle::TrackAssemblyBandBushing::GetIdlerLocation | ( |  | ) | const
| inlineoverridevirtual

Get the relative location of the idler subsystem.

The track assembly reference frame is ISO, with origin at the sprocket center.

Implements chrono::vehicle::ChTrackAssembly.

## ◆ GetRoadWhelAssemblyLocation()

virtual const ChVector3d chrono::vehicle::TrackAssemblyBandBushing::GetRoadWhelAssemblyLocation | ( | int | which | ) | const
| inlineoverridevirtual

Get the relative location of the specified suspension subsystem.

The track assembly reference frame is ISO, with origin at the sprocket center.

Implements chrono::vehicle::ChTrackAssembly.

## ◆ GetRollerLocation()

virtual const ChVector3d chrono::vehicle::TrackAssemblyBandBushing::GetRollerLocation | ( | int | which | ) | const
| inlineoverridevirtual

Get the relative location of the specified roller subsystem.

The track assembly reference frame is ISO, with origin at the sprocket center.

Reimplemented from chrono::vehicle::ChTrackAssembly.

## ◆ GetSprocketLocation()

virtual const ChVector3d chrono::vehicle::TrackAssemblyBandBushing::GetSprocketLocation | ( |  | ) | const
| inlineoverridevirtual

Get the relative location of the sprocket subsystem.

The track assembly reference frame is ISO, with origin at the sprocket center.

Implements chrono::vehicle::ChTrackAssembly.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/track_assembly/TrackAssemblyBandBushing.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/track_assembly/TrackAssemblyBandBushing.cpp